
#property copyright "Copyright  2008,Risdyanto "
#property link      ""
 
extern int  numBars = 5;
extern int      lot = 1;
extern int maPeriod = 14;
extern int timeFrame =5;
string trendType,trendType2;
string Signal;
int index;
int time;
extern int stop = 60;
extern int limit = 200;
extern int TrailingStart=50;
extern int TrailingSize=30;
 
extern int daysBackForHigh = 1;
extern int daysBackForLow = 1;
double Rates[][6];
double fib000,fib236, fib382, fib50, fib618,fib764,fib127, fib100,fib1618,fib2618,fib4236,
       range,prevRange, high,low;
bool objectsExist, highFirst;
 
 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
    
    ObjectCreate("lblTrendType",OBJ_LABEL,0,0,0,0,0);
    ObjectSet("lblTrendType",OBJPROP_XDISTANCE,50);
    ObjectSet("lblTrendType",OBJPROP_YDISTANCE,20);
    ObjectSetText("lblTrendType","TrendType",14,"Tahoma",Red);
   
    ObjectCreate("lblTrendType2",OBJ_LABEL,0,0,0,0,0);
    ObjectSet("lblTrendType2",OBJPROP_XDISTANCE,50);
    ObjectSet("lblTrendType2",OBJPROP_YDISTANCE,50);
    ObjectSetText("lblTrendType2","Signal",14,"Tahoma",Red);
   
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
   ObjectDelete("fib000");
   ObjectDelete("fib000_label");
   ObjectDelete("fib236");
   ObjectDelete("fib236_label");
   ObjectDelete("fib382");
   ObjectDelete("fib382_label");
   ObjectDelete("fib50");
   ObjectDelete("fib50_label");
   ObjectDelete("fib618");
   ObjectDelete("fib618_label");
   ObjectDelete("fib100");
   ObjectDelete("fib100_label");
   ObjectDelete("fib1618");
   ObjectDelete("fib1618_label");
   ObjectDelete("fib2618");
   ObjectDelete("fib2618_label");
   ObjectDelete("fib4236");
   ObjectDelete("fib4236_label");
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  MarketAnalize();
  if(OrdersTotal()==0)
   CheckForOpen();
  else
   CheckForClose();
//----
   return(0);
  }
 
void MarketAnalize()
 
{
  
   
//--------------------------------------------------------------------------------  
  double ma = iMA(Symbol(),timeFrame,maPeriod,0,MODE_SMA,PRICE_CLOSE,0);
  
  if(Ask>ma)
  {
    trendType = "Naik";
  }
  if(Bid<ma)
  {
    trendType = "Turun";
  } 
 
  ObjectSetText("lblTrendType",trendType);
 
 int i = 0;
   prevRange = 0;
   objectsExist = false;
   ArrayCopyRates(Rates, Symbol(), PERIOD_D1);   
   high = Rates[daysBackForHigh][3];
   low = Rates[daysBackForLow][2];
   range = high - low;
//----
   while(true) 
     {
       if(High[i] == high) 
         {
           highFirst = true;
           break;
         }
       else 
           if(Low[i] == low) 
             {
               highFirst = false;
               break;
             }
       i++;
     }
   // Delete Objects if necessary
   if(prevRange != range) 
     {
       ObjectDelete("fib000");
       ObjectDelete("fib000_label");
       ObjectDelete("fib236");
       ObjectDelete("fib236_label");
       ObjectDelete("fib382");
       ObjectDelete("fib382_label");
       ObjectDelete("fib50");
       ObjectDelete("fib50_label");
       ObjectDelete("fib618");
       ObjectDelete("fib618_label");
       ObjectDelete("fib764");
       ObjectDelete("fib764_label");
       ObjectDelete("fib100");
       ObjectDelete("fib100_label");
       ObjectDelete("fib127");
       ObjectDelete("fib127_label");
       ObjectDelete("fib1618");
       ObjectDelete("fib1618_label");
       ObjectDelete("fib2618");
       ObjectDelete("fib2618_label");
       ObjectDelete("fib4236");
       ObjectDelete("fib4236_label");
       objectsExist = false;
       prevRange = range;
     }
//----
   if(highFirst == true) 
     {
       fib000 = low;
       fib236 = (range * 0.236) + low;
       fib382 = (range * 0.382) + low;
       fib50 = (high + low) / 2;
       fib618 = (range * 0.618) + low;
       fib764 = (range * 0.764) + low;
       fib100 = high;
       fib127 = (range * 0.276) + high;
       fib1618 = (range * 0.618) + high;
       fib2618 = (range * 0.618) + (high + range);
       fib4236 = (range * 0.236) + high + (range * 3);
     }
   else 
       if(highFirst == false) 
         {
           fib000 = high;
           fib236 = high - (range * 0.236);
           fib382 = high - (range * 0.382);
           fib50  = (high + low) / 2;
           fib618 = high - (range * 0.618);
           fib764 = high - (range * 0.764);
           fib100 = low;
           fib127 = low - (range * 0.276);
           fib1618 = low - (range * 0.618);
           fib2618 = (low - range) - (range * 0.618);// + (high + range);
           fib4236 = low - (range * 3) - (range * 0.236);// + high + (range * 3);
         }
//----   
   if(objectsExist == false) 
     {
       ObjectCreate("fib000", OBJ_HLINE, 0, Time[40], fib000);
       ObjectSet("fib000", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib000", OBJPROP_COLOR, Red);
       ObjectCreate("fib000_label", OBJ_TEXT, 0, Time[0], fib000);
       ObjectSetText("fib000_label","                             0.0", 8, "Times", White);
       //----
       ObjectCreate("fib236", OBJ_HLINE, 0, Time[40], fib236);
       ObjectSet("fib236", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib236", OBJPROP_COLOR, Red);
       ObjectCreate("fib236_label", OBJ_TEXT, 0, Time[0], fib236);
       ObjectSetText("fib236_label","                             23.6", 8, "Times", White);
       //----
       ObjectCreate("fib382", OBJ_HLINE, 0, Time[40], fib382);
       ObjectSet("fib382", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib382", OBJPROP_COLOR, Red);
       ObjectCreate("fib382_label", OBJ_TEXT, 0, Time[0], fib382);
       ObjectSetText("fib382_label","                             38.2", 8, "Times", White);
       //----
       ObjectCreate("fib50", OBJ_HLINE, 0, Time[40], fib50);
       ObjectSet("fib50", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib50", OBJPROP_COLOR, Red);
       ObjectCreate("fib50_label", OBJ_TEXT, 0, Time[0], fib50);
       ObjectSetText("fib50_label","                             50.0", 8, "Times", White);
       //----
       ObjectCreate("fib618", OBJ_HLINE, 0, Time[40], fib618);
       ObjectSet("fib618", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib618", OBJPROP_COLOR, Red);
       ObjectCreate("fib618_label", OBJ_TEXT, 0, Time[0], fib618);
       ObjectSetText("fib618_label","                             61.8", 8, "Times", White);
       //----
       ObjectCreate("fib764", OBJ_HLINE, 0, Time[40], fib764);
       ObjectSet("fib764", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib764", OBJPROP_COLOR, Red);
       ObjectCreate("fib764_label", OBJ_TEXT, 0, Time[0], fib764);
       ObjectSetText("fib764_label","                             76.4", 8, "Times", White);
       //----
 
       ObjectCreate("fib100", OBJ_HLINE, 0, Time[40], fib100);
       ObjectSet("fib100", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib100", OBJPROP_COLOR, Red);
       ObjectCreate("fib100_label", OBJ_TEXT, 0, Time[0], fib100);
       ObjectSetText("fib100_label","                             100.0", 8, "Times", White);
       //----
       ObjectCreate("fib127", OBJ_HLINE, 0, Time[40], fib127);
       ObjectSet("fib127", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib127", OBJPROP_COLOR, Red);
       ObjectCreate("fib127_label", OBJ_TEXT, 0, Time[0], fib127);
       ObjectSetText("fib127_label","                             127.6", 8, "Times", White);
       //----
       ObjectCreate("fib1618", OBJ_HLINE, 0, Time[40], fib1618);
       ObjectSet("fib1618", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib1618", OBJPROP_COLOR, Red);
       ObjectCreate("fib1618_label", OBJ_TEXT, 0, Time[0], fib1618);
       ObjectSetText("fib1618_label","                             161.8", 8, "Times", White);
       //----
       ObjectCreate("fib2618", OBJ_HLINE, 0, Time[40], fib2618);
       ObjectSet("fib2618", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib2618", OBJPROP_COLOR, Red);
       ObjectCreate("fib2618_label", OBJ_TEXT, 0, Time[0], fib2618);
       ObjectSetText("fib2618_label","                             261.8", 8, "Times", White);
       //----
       ObjectCreate("fib4236", OBJ_HLINE, 0, Time[40], fib4236);
       ObjectSet("fib4236", OBJPROP_STYLE, STYLE_DASHDOTDOT);
       ObjectSet("fib4236", OBJPROP_COLOR, Red);
       ObjectCreate("fib4236_label", OBJ_TEXT, 0, Time[0], fib4236);
       ObjectSetText("fib4236_label","                             423.6", 8, "Times", White);
     
   
     if(highFirst == true)   
     {if (Open[0] < fib236 )   {Signal = "Reverse-Buy";}
      if (Open[0] > fib764 )   {Signal = "Reverse-Sell";}
     }
     else 
       if(highFirst == false)  
     {if (Open[0] > fib236 )    {Signal = "Reverse-Sell";}
      if (Open[0] < fib764 )    {Signal = "Reverse_Buy";}
    }
     
       
        ObjectSetText("lblTrendType2",Signal);
}
  }
 
 
//------------------------------------------------------------------------
void CheckForOpen()
{
   if ((trendType=="Naik") && (highFirst==true))
  { if(Ask >= fib100) 
     OrderSend(Symbol(), OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-limit*Point);
    OrderSend(Symbol(), OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+limit*Point);}
 /* 
   if((trendType=="Turun")  && (highFirst == true))
  { if(Bid>fib764) 
   OrderSend(Symbol(), OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-limit*Point);}
  
   if((trendType=="Naik") && (highFirst == true))
  { if(Bid<fib236) 
   OrderSend(Symbol(), OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+limit*Point);}*/
 
  if((trendType=="Turun") && (highFirst==false))
  { if(Bid <=fib100)  
   OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-limit*Point);
   OrderSend(Symbol(), OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+limit*Point); }
 /* 
  if((trendType=="Turun") && (highFirst == false))
  { if(Bid>fib236) OrderSend(Symbol(), OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-limit*Point);}
  
  if((trendType=="Naik") && (highFirst == false))
  { if(Ask<fib764) OrderSend(Symbol(), OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+limit*Point);}*/
  
}
 
//------------------------------------------------------------------
void CheckForClose()
{
 OrderSelect(0,SELECT_BY_POS);
 
if(OrderType()==OP_BUY)
 //{
   {
      if (Bid-OrderOpenPrice() > TrailingStart*Point) 
      {
        if (OrderStopLoss() < Bid - (TrailingSize+1)*Point) 
        {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-TrailingSize*Point, OrderTakeProfit(), 0, Silver);
        }
      }
    }
 /*   //if((Ask>OrderOpenPrice()+Point*20)&&(OrderStopLoss()<(OrderOpenPrice()+Point*15)))
  //  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*15,OrderTakeProfit(),0,Blue);
   // if((Ask>OrderOpenPrice()+Point*30)&&(OrderStopLoss()<(OrderOpenPrice()+Point*25)))
  //  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*25,OrderTakeProfit(),0,Blue);
 //   if((Ask>OrderOpenPrice()+Point*40)&&(OrderStopLoss()<(OrderOpenPrice()+Point*35)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*35,OrderTakeProfit(),0,Blue);    
 //   if((Ask>OrderOpenPrice()+Point*60)&&(OrderStopLoss()<(OrderOpenPrice()+Point*55)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*55,OrderTakeProfit(),0,Blue);
  //  if((Ask>OrderOpenPrice()+Point*80)&&(OrderStopLoss()<(OrderOpenPrice()+Point*75)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*75,OrderTakeProfit(),0,Blue);
  //  if((Ask>OrderOpenPrice()+Point*100)&&(OrderStopLoss()<(OrderOpenPrice()+Point*95)))
  //  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*95,OrderTakeProfit(),0,Blue);
  //  if((Ask>OrderOpenPrice()+Point*120)&&(OrderStopLoss()<(OrderOpenPrice()+Point*115)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*115,OrderTakeProfit(),0,Blue);
  //  if((Ask>OrderOpenPrice()+Point*140)&&(OrderStopLoss()<(OrderOpenPrice()+Point*135)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*135,OrderTakeProfit(),0,Blue);
    if((Ask>OrderOpenPrice()+Point*160)&&(OrderStopLoss()<(OrderOpenPrice()+Point*100)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*100,OrderTakeProfit(),0,Blue);
    if((Ask>OrderOpenPrice()+Point*180)&&(OrderStopLoss()<(OrderOpenPrice()+Point*120)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*120,OrderTakeProfit(),0,Blue);
    if((Ask>OrderOpenPrice()+Point*200)&&(OrderStopLoss()<(OrderOpenPrice()+Point*140)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*140,OrderTakeProfit(),0,Blue);
    if((Ask>OrderOpenPrice()+Point*220)&&(OrderStopLoss()<(OrderOpenPrice()+Point*160)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*160,OrderTakeProfit(),0,Blue);
    if((Ask>OrderOpenPrice()+Point*240)&&(OrderStopLoss()<(OrderOpenPrice()+Point*180)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*180,OrderTakeProfit(),0,Blue);
    if((Ask>OrderOpenPrice()+Point*260)&&(OrderStopLoss()<(OrderOpenPrice()+Point*200)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*200,OrderTakeProfit(),0,Blue); 
    */      
// }
 if(OrderType()==OP_SELL)
// {
  {
      if (OrderOpenPrice()-Ask > TrailingStart*Point) 
      {
        if (OrderStopLoss() > Ask + (TrailingSize+1)*Point || OrderStopLoss() == 0) 
        {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+TrailingSize*Point, OrderTakeProfit(), 0, Silver);
        }
      }
    }
 /* // if((Bid<OrderOpenPrice()-Point*20)&&(OrderStopLoss()>(OrderOpenPrice()-Point*15)))
//    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*15,OrderTakeProfit(),0,Blue);   
 //  if((Bid<OrderOpenPrice()-Point*30)&&(OrderStopLoss()>(OrderOpenPrice()-Point*25)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*25,OrderTakeProfit(),0,Blue);   
//   if((Bid<OrderOpenPrice()-Point*40)&&(OrderStopLoss()>(OrderOpenPrice()-Point*35)))
//    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*35,OrderTakeProfit(),0,Blue);     
//   if((Bid<OrderOpenPrice()-Point*60)&&(OrderStopLoss()>(OrderOpenPrice()-Point*55)))
  //  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*55,OrderTakeProfit(),0,Blue);     
 //  if((Bid<OrderOpenPrice()-Point*80)&&(OrderStopLoss()>(OrderOpenPrice()-Point*75)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*75,OrderTakeProfit(),0,Blue);
 //if((Bid<OrderOpenPrice()-Point*100)&&(OrderStopLoss()>(OrderOpenPrice()-Point*95)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*95,OrderTakeProfit(),0,Blue);
 ////  if((Bid<OrderOpenPrice()-Point*120)&&(OrderStopLoss()>(OrderOpenPrice()-Point*115)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*115,OrderTakeProfit(),0,Blue);
//  if((Bid<OrderOpenPrice()-Point*140)&&(OrderStopLoss()>(OrderOpenPrice()-Point*135)))
 //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*135,OrderTakeProfit(),0,Blue);
   if((Bid<OrderOpenPrice()-Point*160)&&(OrderStopLoss()>(OrderOpenPrice()-Point*100)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*100,OrderTakeProfit(),0,Blue);
   if((Bid<OrderOpenPrice()-Point*180)&&(OrderStopLoss()>(OrderOpenPrice()-Point*120)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*120,OrderTakeProfit(),0,Blue);
   if((Bid<OrderOpenPrice()-Point*200)&&(OrderStopLoss()>(OrderOpenPrice()-Point*140)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*140,OrderTakeProfit(),0,Blue);
    if((Bid<OrderOpenPrice()-Point*220)&&(OrderStopLoss()>(OrderOpenPrice()-Point*160)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*160,OrderTakeProfit(),0,Blue);
   if((Bid<OrderOpenPrice()-Point*240)&&(OrderStopLoss()>(OrderOpenPrice()-Point*180)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*180,OrderTakeProfit(),0,Blue);
   if((Bid<OrderOpenPrice()-Point*260)&&(OrderStopLoss()>(OrderOpenPrice()-Point*200)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*200,OrderTakeProfit(),0,Blue);
  }*/
}
//+------------------------------------------------------------------+